// cabfile.h
//
// Copyright (C) 2000  Robert Barron, KA5WSS
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _CABFILE_H_
#define _CABFILE_H_

#include "qsodata.h"
#include "qsofile.h"

#define CAB_FILE_VER			"2.0"

#define MAX_CAB_LINE_SIZE		132

#define CAB_FIELD_ADDRESS		"ADDRESS:"
#define CAB_FIELD_CALLSIGN		"CALLSIGN:"
#define CAB_FIELD_CATEGORY		"CATEGORY:"
#define CAB_FIELD_CATEGORY_OV   "CATEGORY-OVERLAY:"
#define CAB_FIELD_CLAIMED_SCORE "CLAIMED-SCORE:"
#define CAB_FIELD_CLUB			"CLUB:"
#define CAB_FIELD_CONTEST		"CONTEST:"
#define CAB_FIELD_END			"END-OF-LOG:"
#define CAB_FIELD_NAME			"NAME:"
#define CAB_FIELD_OPERATORS		"OPERATORS:"
#define CAB_FIELD_QSO			"QSO:"
#define CAB_FIELD_SECTION		"ARRL-SECTION:"
#define CAB_FIELD_SCORE			"CLAIMED-SCORE:"
#define CAB_FIELD_SOAPBOX		"SOAPBOX:"
#define CAB_FIELD_START			"START-OF-LOG:"

#define CAB_QSO_TIME			"QSO: %5s %2s %4d-%02d-%02d %02d%02d "
#define CAB_QSO_SS				"%-10s %4d %c %2s %3s %-10s %4d %c %2d %-3s"
#define CAB_QSO_QP				"%-10s %-4s %-10s %-3s %-10s %-4s %-10s %-3s  "
#define CAB_QSO_OTHER			"%-13s %-3d %-6s %-13s %-3d %-6s  "
#define CAB_QSO_SPRINT			"%-10s %-4d %-10s %-3s %-10s %-4d %-10s %-3s  "
#define CAB_QSO_VHF				"%-13s %-3s %-6s %-13s %-3s %-6s  "

class RCabFile : public RQsoFile
{
private:
//	int location;

	typedef struct log_data_struct
	{
		char band[4];
		char mode[4];
		char day[2];
		char slash1;
		char month[2];
		char slash2;
		char year[2];
		char filler;
		char time[4];
		char filler2;
		char qsoNum[6];
		char callsign[15];
		char sent[5];
		char rcvd[5];
		char mult[3];
		char qsoPoints[3];
		char WhatIsThis;
	} arrl_log_data;

public:
	static char *modes[];
	static char *bands[];
	static char *contests[];
	static char *categories[];
	static char *powerCategories[];

	RCabFile()						{ location = 0; };
	RCabFile(char *filename);
	boolean open(char *name, int mode = ios::in | ios::binary);
	boolean close();
	// Support for this may be added later.
	virtual boolean nextQso(qso_data *); /* Return next generic QSO record */

	virtual boolean writeHeader(header_data);
	virtual boolean writeQso(qso_data *);
};
#endif
